﻿namespace Tenma.HomeMatic.Remoting.SampleClient
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.Data;
    using System.Drawing;
    using System.Text;
    using System.Windows.Forms;

    using Tenma.HomeMatic.Remoting;
    using Tenma.HomeMatic.Remoting.SampleClient.Samples;

    public partial class MainForm : Form
    {
        private const string DefaultUrl = "http://127.0.0.1:2001/";

        private IRpcProxy proxy;
        private ChooseUrlDialog chooseUrlDialog;

        public MainForm()
        {
            this.InitializeComponent();
            this.chooseUrlDialog = new ChooseUrlDialog();
            this.proxy = RpcProxyFactory.Create(MainForm.DefaultUrl);

            this.listBox.Items.Add(new ListDevicesControl(this.proxy));
            this.listBox.Items.Add(new GetValueControl(this.proxy));
            this.listBox.Items.Add(new ListBidcosinterfacesControl(this.proxy));
            this.listBox.Items.Add(new GetLinksControl(proxy));
            this.listBox.Items.Add(new GetServiceMessagesControl(proxy));
            this.listBox.Items.Add(new GetParamsetControl(this.proxy));
            this.listBox.Items.Add(new GetRssiInfoControl(this.proxy));
            this.listBox.Items.Add(new GetParamsetDescriptionControl(this.proxy));

            this.listBox.SelectedIndex = 0;
        }

        private void MainForm_Shown(object sender, EventArgs e)
        {
            if (this.chooseUrlDialog.ShowDialog() == DialogResult.OK)
            {
                this.proxy.Url = this.chooseUrlDialog.Url;
            }
            else
            {
                this.Close();
            }
        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (this.listBox.SelectedItem is UserControl)
            {
                UserControl control = (UserControl) this.listBox.SelectedItem;
                this.splitContainer1.Panel2.Controls.Clear();
                this.splitContainer1.Panel2.Controls.Add(control);

                control.Dock = DockStyle.Fill;
            }
        }

        private void QuitMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void chooseUrlMenuItem_Click(object sender, EventArgs e)
        {
            if (this.chooseUrlDialog.ShowDialog() == DialogResult.OK)
            {
                this.proxy.Url = this.chooseUrlDialog.Url;
            }
        }


    }
}
