﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace Tenma.HomeMatic.Remoting.SampleClient.Samples
{
    public partial class GetLinksControl : UserControl
    {
        private IRpcProxy proxy;

        public GetLinksControl()
            : this(null)
        {
        }

        public GetLinksControl(IRpcProxy proxy)
        {
            this.InitializeComponent();
            this.proxy = proxy;
        }

        private void GteLinksButton_Click(object sender, EventArgs e)
        {
            try
            {
                this.listView.Items.Clear();
                this.listView.Refresh();

                foreach (ILinkDescription linkDescription in this.proxy.GetLinks("", 0))
                {
                    ListViewItem item = new ListViewItem();
                    item.Tag = linkDescription;
                    item.Text = linkDescription.Sender;

                    item.SubItems.Add(linkDescription.Receiver);
                    item.SubItems.Add(linkDescription.Flags.ToString());
                    item.SubItems.Add(linkDescription.Name);
                    item.SubItems.Add(linkDescription.Description);

                    this.listView.Items.Add(item);
                }

                this.listView.AutoResizeColumns(ColumnHeaderAutoResizeStyle.ColumnContent);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString(), "Fehler");
            }
        }

        public override string ToString()
        {
            return "GetLinks";
        }
    }
}
