﻿namespace Tenma.HomeMatic.Remoting.SampleClient.Samples
{
    using System;
    using System.Collections;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.Drawing;
    using System.Data;
    using System.Text;
    using System.Windows.Forms;

    public partial class GetParamsetControl : UserControl
    {
        private IRpcProxy proxy;

        public GetParamsetControl()
            : this(null)
        {
        }

        public GetParamsetControl(IRpcProxy proxy)
        {
            this.InitializeComponent();
            this.proxy = proxy;
        }

        private void getParamsetButton_Click(object sender, EventArgs e)
        {
            try
            {
                this.listView.Items.Clear();
                this.listView.Refresh();

                string address = this.addressTextBox.Text;
                string paramsetKey = this.paramsetKeyTextBox.Text;
                Hashtable paramset = this.proxy.GetParamset(address, paramsetKey);

                foreach (String key in paramset.Keys)
                {
                    ListViewItem item = new ListViewItem();
                    item.Text = key;
                    item.SubItems.Add(paramset[key].ToString());
                    this.listView.Items.Add(item);
                }

                this.listView.AutoResizeColumns(ColumnHeaderAutoResizeStyle.ColumnContent);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString(), "Fehler");
            }
        }

        public override string ToString()
        {
            return "GetParamset";
        }
    }
}
