﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace Tenma.HomeMatic.Remoting.SampleClient.Samples
{
    public partial class GetParamsetDescriptionControl : UserControl
    {
        private IRpcProxy proxy;

        public GetParamsetDescriptionControl()
            : this(null)
        {
        }

        public GetParamsetDescriptionControl(IRpcProxy proxy)
        {
            this.InitializeComponent();
            this.proxy = proxy;
        }

        private void getParamsetDescriptionButton_Click(object sender, EventArgs e)
        {
            try
            {
                this.listView.Items.Clear();
                this.listView.Refresh();

                string address = this.addressTextBox.Text;
                string paramsetType = this.typeTextBox.Text;

                Dictionary<string, IParameterDescription> paramsetDescription = this.proxy.GetParamsetDescription(address, paramsetType);
                foreach (string key in paramsetDescription.Keys)
                {
                    ListViewItem item = new ListViewItem();
                    item.Tag = paramsetDescription[key];
                    item.Text = key;

                    item.SubItems.Add(paramsetDescription[key].ParameterType);
                    item.SubItems.Add(paramsetDescription[key].DefaultValue.ToString());

                    this.listView.Items.Add(item);
                }

                this.listView.AutoResizeColumns(ColumnHeaderAutoResizeStyle.ColumnContent);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString(), "Fehler");
            }
        }

        public override string ToString()
        {
            return "GetParamsetDescription";
        }
    }
}
