﻿namespace Tenma.HomeMatic.Remoting.SampleClient.Samples
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.Drawing;
    using System.Data;
    using System.Text;
    using System.Windows.Forms;

    public partial class GetRssiInfoControl : UserControl
    {
        private IRpcProxy proxy;

        public GetRssiInfoControl()
            : this(null)
        {
        }

        public GetRssiInfoControl(IRpcProxy proxy)
        {
            this.InitializeComponent();
            this.proxy = proxy;
        }

        private void getRssiInfoButton_Click(object sender, EventArgs e)
        {
            try
            {
                this.listView.Items.Clear();
                this.listView.Refresh();

                foreach (RssiInfo rssiInfo in this.proxy.GetRssiInfo())
                {
                    ListViewItem item = new ListViewItem();
                    item.Tag = rssiInfo;
                    item.Text = rssiInfo.Sender;

                    item.SubItems.Add(rssiInfo.Receiver);
                    item.SubItems.Add(rssiInfo.IsValid ? rssiInfo.RssiValue.ToString() : "ungültig");

                    this.listView.Items.Add(item);
                }

                this.listView.AutoResizeColumns(ColumnHeaderAutoResizeStyle.ColumnContent);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString(), "Fehler");
            }
        }

        public override string ToString()
        {
            return "GetRssiInfo";
        }
    }
}
