﻿namespace Tenma.HomeMatic.Remoting.SampleClient.Samples
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.Drawing;
    using System.Data;
    using System.Text;
    using System.Windows.Forms;

    public partial class GetServiceMessagesControl : UserControl
    {
        private IRpcProxy proxy;

        public GetServiceMessagesControl()
            : this(null)
        {
        }

        public GetServiceMessagesControl(IRpcProxy proxy)
        {
            this.InitializeComponent();
            this.proxy = proxy;
        }

        private void getServiceMessagesButton_Click(object sender, EventArgs e)
        {
            try
            {
                this.listView.Items.Clear();
                this.listView.Refresh();

                foreach (IServiceMessage serviceMessage in this.proxy.GetServiceMessages())
                {
                    ListViewItem item = new ListViewItem();
                    item.Tag = serviceMessage;
                    item.Text = serviceMessage.Address;

                    item.SubItems.Add(serviceMessage.Id);
                    item.SubItems.Add(serviceMessage.Value.ToString());

                    this.listView.Items.Add(item);
                }

                this.listView.AutoResizeColumns(ColumnHeaderAutoResizeStyle.ColumnContent);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString(), "Fehler");
            }
        }

        public override string ToString()
        {
            return "GetServieMessages";
        }
    }
}
