﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace Tenma.HomeMatic.Remoting.SampleClient.Samples
{
    public partial class ListBidcosinterfacesControl : UserControl
    {
        private IRpcProxy proxy;

        public ListBidcosinterfacesControl()
            : this(null)
        {
        }

        public ListBidcosinterfacesControl(IRpcProxy proxy)
        {
            this.InitializeComponent();
            this.proxy = proxy;
        }

        private void listBidcosInterfacesButton_Click(object sender, EventArgs e)
        {
            try
            {
                this.listView.Items.Clear();
                this.listView.Refresh();

                foreach (IBidcosInterface bidcosInterface in this.proxy.ListBidcosInterfaces())
                {
                    ListViewItem item = new ListViewItem();
                    item.Tag = bidcosInterface;
                    item.Text = bidcosInterface.Address;

                    item.SubItems.Add(bidcosInterface.Description);
                    item.SubItems.Add(bidcosInterface.IsConnected.ToString());
                    item.SubItems.Add(bidcosInterface.IsDefault.ToString());

                    listView.Items.Add(item);
                }

                this.listView.AutoResizeColumns(ColumnHeaderAutoResizeStyle.ColumnContent);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString(), "Fehler");
            }
        }

        public override string ToString()
        {
            return "ListBidcosInterfaces";
        }
    }
}
