﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace Tenma.HomeMatic.Remoting.SampleClient.Samples
{
    public partial class ListDevicesControl : UserControl
    {
        private IRpcProxy proxy;

        public ListDevicesControl()
            : this(null)
        {
        }

        public ListDevicesControl(IRpcProxy proxy)
        {
            this.InitializeComponent();
            this.proxy = proxy;
        }


        private void ListDevicesButton_Click(object sender, EventArgs e)
        {
            try
            {
                this.listView.Items.Clear();
                this.listView.Refresh();

                foreach (IDeviceDescription deviceDescription in this.proxy.ListDevices())
                {
                    ListViewItem item = new ListViewItem();
                    item.Tag = deviceDescription;
                    item.Text = deviceDescription.Address;
                    item.SubItems.Add(deviceDescription.DeviceType);

                    this.listView.Items.Add(item);
                }

                this.listView.AutoResizeColumns(ColumnHeaderAutoResizeStyle.ColumnContent);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString(), "Fehler");
            }
        }

        public override string ToString()
        {
            return "ListDevices";
        }
    }
}
