﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Xml;

using Tenma.HomeMatic.Remoting;

namespace ScriptSample
{
    public partial class MainForm : Form
    {
        private ScriptProxy proxy;
        private IPDialog ipDialog;


        public MainForm()
        {
            InitializeComponent();
            this.ipDialog = new IPDialog();
            this.proxy = new ScriptProxy(IPAddress.Parse("192.168.2.10"));
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.stdoutTextBox.Clear();
            this.stdoutTextBox.Update();
            this.listView.Items.Clear();
            this.listView.Update();

            IScriptResponse response = this.proxy.Invoke(this.sourceTextBox.Text);
            this.stdoutTextBox.Text = response.Stdout;

            foreach (string name in response.Keys)
            {
                ListViewItem item = new ListViewItem();
                item.Text = name;
                item.SubItems.Add(response[name]);

                this.listView.Items.Add(item);
            }
        }

        private void MainForm_Shown(object sender, EventArgs e)
        {
            if (ipDialog.ShowDialog() == DialogResult.OK)
            {
                this.proxy.IPAddress = ipDialog.IPAddress;
            }
        }
    }
}
