﻿namespace Tenma.HomeMatic.Remoting
{
    using System.Collections;

    /// <summary>
    /// Definiert eine Verknüpfungsbeschreibung.
    /// </summary>
    public interface ILinkDescription
    {
        /// <summary>
        /// Liefert die Seriennummer des Senders.
        /// </summary>
        string Sender { get; }

        /// <summary>
        /// Liefert die Seriennummer des Empfängers.
        /// </summary>
        string Receiver { get; }

        /// <summary>
        /// Liefert die Flags für die Verknüpfung.
        /// </summary>
        int Flags { get; }

        /// <summary>
        /// Liefert den Namen der Verknüpfung.
        /// </summary>
        string Name { get; }

        /// <summary>
        /// Liefert die Beschreibung der Verknüpfung.
        /// </summary>
        string Description { get; }

        /// <summary>
        /// Liefert das Paramset des Sender.
        /// </summary>
        Hashtable SenderParamset { get; }

        /// <summary>
        /// Liefert das Paramset des Empfängers.
        /// </summary>
        Hashtable ReceiverParamset { get; }
    }
}
