﻿namespace Tenma.HomeMatic.Remoting
{
    using Tenma.HomeMatic.Remoting.XmlRpc.Net;

    /// <summary>
    /// Factory für die Erzeugung von Proxys für
    /// die Kommunikation.
    /// </summary>
    public class RpcProxyFactory
    {
        /// <summary>
        /// Erzeugt einen Proxy für die Kommunikation.
        /// </summary>
        /// <param name="url">Url des BidCoS-Services</param>
        /// <returns>Proxy für die Kommunikation</returns>
        public static IRpcProxy Create(string url)
        {
            RpcProxy result = new RpcProxy();
            result.Url = url;
            
            return result;
        }
    }
}
