﻿namespace Tenma.HomeMatic.Remoting.XmlRpc.Net
{
    using System;
    using System.Collections.Generic;
    using System.Text;

    using CookComputing.XmlRpc;

    public interface IProxy: IXmlRpcProxy
    {

        [XmlRpcMethod("activateLinkParamset")]
        void ActivateLinkParamset(string address, string peerAddress, bool longPress);

        [XmlRpcMethod("addDevice")]
        DeviceDescription AddDevice(string serialNumber);

        [XmlRpcMethod("addLink")]
        void AddLink(string sender, string receiver, string name, string description);

        [XmlRpcMethod("changeKey")]
        void ChangeKey(string passphrase);

        [XmlRpcMethod("clearConfigCache")]
        void ClearConfigCache(string address);

        [XmlRpcMethod("deleteDevice")]
        void DeleteDevice(string address, int flags);

        [XmlRpcMethod("determineParameter")]
        void DetermineParameter(string address, string paramsetKey, string parameterId);

        [XmlRpcMethod("getDeviceDescription")]
        DeviceDescription GetDeviceDescription(string address);

        [XmlRpcMethod("getInstallMode")]
        int GetInstallMode();

        [XmlRpcMethod("getKeyMissmatchDevice")]
        string GetKeyMissmatchDevice(bool reset);

        [XmlRpcMethod("getLinkInfo")]
        string[] GetLinkInfo(string sender, string receiver);

        [XmlRpcMethod("getLinkPeers")]
        string[] GetLinkPeers(string address);

        [XmlRpcMethod("getLinks")]
        LinkDescription[] GetLinks(string address, int flags);

        [XmlRpcMethod("getParamset")]
        XmlRpcStruct GetParamset(string address, string paramsetKey);

        [XmlRpcMethod("getParamsetDescription")]
        XmlRpcStruct GetParamsetDescription(string address, string type);

        [XmlRpcMethod("getParamsetId")]
        string GetParamsetId(string address, string type);

        [XmlRpcMethod("getValue")]
        object GetValue(string address, string valueKey);

        [XmlRpcMethod("init")]
        void Init(string url, string interfaceId);

        [XmlRpcMethod("init")]
        void Shutdown(string url);

        [XmlRpcMethod("listDevices")]
        DeviceDescription[] ListDevices();

        [XmlRpcMethod("listTeams")]
        DeviceDescription[] listTeams();

        [XmlRpcMethod("logLevel")]
        int GetLogLevel();

        [XmlRpcMethod("logLevel")]
        int SetLogLevel(int logLevel);

        [XmlRpcMethod("putParamset")]
        void PutParamset(string addres, string paramsetKey, XmlRpcStruct paramset);

        [XmlRpcMethod("removeLink")]
        void RemoveLink(string sender, string receiver);

        [XmlRpcMethod("reportValueUsage")]
        bool ReportValueUsage(string address, string valueId, int refCounter);

        [XmlRpcMethod("restoreConfigToDevice")]
        void RestoreConfigToDevice(string address);

        [XmlRpcMethod("rssiInfo")]
        XmlRpcStruct GetRssiInfo();

        [XmlRpcMethod("searchDevices")]
        int SearchDevices();

        [XmlRpcMethod("setInstallMode")]
        void SetInstallMode(bool isOn);

        [XmlRpcMethod("setLinkInfo")]
        void SetLinkInfo(string sender, string receiver, string name, string description);

        [XmlRpcMethod("setTeam")]
        void SetTeam(string channelAddress, string teamAddress);

        [XmlRpcMethod("setTempKey")]
        void SetTempKey(string passphrase);

        [XmlRpcMethod("setValue")]
        void SetValue(string address, string valueKey, object value);

        [XmlRpcMethod("updateFirmware")]
        bool[] UpdateFirmware(string[] deviceAddresses);

        [XmlRpcMethod("listBidcosInterfaces")]
        BidcosInterface[] ListBidcosInterfaces();

        [XmlRpcMethod("setBidcosInterface")]
        void SetBidCosIntrface(string devieAddress, string interfaceAddress, bool useRoaming);

        [XmlRpcMethod("getServiceMessages")]
        object[] GetServiceMessages();

        [XmlRpcMethod("getMetadata")]
        object GetMetadata(string objectId, string dataId);

        [XmlRpcMethod("setMetadata")]
        void SetMetadata(string objectId, string dataId, object value);

        [XmlRpcMethod("getAllMetadata")]
        XmlRpcStruct GetAllMetadata(string objectId);
    }
}
