﻿namespace Tenma.HomeMatic.Remoting.XmlRpc.Net
{
using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;

    using CookComputing.XmlRpc;

    public class LinkDescription: ILinkDescription
    {
        private string sender;
        private string receiver;
        private int flags;
        private string name;
        private string description;
        private Hashtable senderParamset;
        private Hashtable receiverParamset;

        public LinkDescription()
        {
            this.sender = string.Empty;
            this.receiver = string.Empty;
            this.flags = 0;
            this.name = string.Empty;
            this.description = string.Empty;
            this.senderParamset = new Hashtable();
            this.receiverParamset = new Hashtable();
        }

        [XmlRpcMember("SENDER")]
        public string Sender
        {
            get
            {
                return this.sender;
            }

            set
            {
                this.sender = value;
            }
        }

        [XmlRpcMember("RECEIVER")]
        public string Receiver
        {
            get
            {
                return this.receiver;
            }

            set
            {
                this.receiver = value;
            }
        }

        [XmlRpcMember("FLAGS")]
        public int Flags
        {
            get
            {
                return this.flags;
            }

            set
            {
                this.flags = value;
            }
        }

        [XmlRpcMember("NAME")]
        public string Name
        {
            get
            {
                return this.name;
            }

            set
            {
                this.name = value;
            }
        }

        [XmlRpcMember("DESCRIPTION")]
        public string Description
        {
            get
            {
                return this.description;
            }

            set
            {
                this.description = value;
            }
        }

        [XmlRpcMember("SENDER_PARAMSET")]
        [XmlRpcMissingMapping(MappingAction.Ignore)]
        public Hashtable SenderParamset
        {
            get
            {
                return this.senderParamset;
            }

            set
            {
                this.senderParamset = value;
            }
        }

        [XmlRpcMember("RECEIVER_PARAMSET")]
        [XmlRpcMissingMapping(MappingAction.Ignore)]
        public Hashtable ReceiverParamset
        {
            get
            {
                return this.receiverParamset;
            }

            set
            {
                this.receiverParamset = value;
            }
        }
    }
}
